/// <reference types="node" />
import { RuleSetRevisionV1 } from './v1';
import { RuleSetRevisionV2 } from './v2';
export type RuleSetRevision = RuleSetRevisionV1 | RuleSetRevisionV2;
export declare const isRuleSetV1: (ruleSet: RuleSetRevision) => ruleSet is RuleSetRevisionV1;
export declare const isRuleSetV2: (ruleSet: RuleSetRevision) => ruleSet is RuleSetRevisionV2;
export declare const serializeRuleSetRevision: (ruleSet: RuleSetRevision) => Buffer;
export declare const deserializeRuleSetRevision: (buffer: Buffer, offset?: number) => RuleSetRevision;
export declare const getRuleSetRevisionFromJson: (json: string) => RuleSetRevision;
export declare const getLatestRuleSetRevision: (data: Buffer) => RuleSetRevision;
