"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRevisionMapV1 = exports.getHeader = void 0;
const bn_js_1 = require("bn.js");
const generated_1 = require("../generated");
const getHeader = (data) => {
    const [header] = generated_1.ruleSetHeaderBeet.deserialize(data.subarray(0, 9));
    return header;
};
exports.getHeader = getHeader;
const getRevisionMapV1 = (data) => {
    const header = (0, exports.getHeader)(data);
    const revisionMapLocation = new bn_js_1.BN(header.revMapVersionLocation).toNumber();
    const [revisionMap] = generated_1.ruleSetRevisionMapV1Beet.deserialize(data.subarray(revisionMapLocation + 1, data.length));
    return revisionMap;
};
exports.getRevisionMapV1 = getRevisionMapV1;
//# sourceMappingURL=revisionMap.js.map