"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeRuleSetRevisionV1 = exports.serializeRuleSetRevisionV1 = void 0;
const msgpack_1 = require("@msgpack/msgpack");
const serializeRuleSetRevisionV1 = (ruleSet) => {
    return Buffer.from((0, msgpack_1.encode)(ruleSet));
};
exports.serializeRuleSetRevisionV1 = serializeRuleSetRevisionV1;
const deserializeRuleSetRevisionV1 = (buffer, offset = 0) => {
    const ruleSet = (0, msgpack_1.decode)(buffer.subarray(offset + 1));
    if (Array.isArray(ruleSet)) {
        return {
            libVersion: ruleSet[0],
            owner: ruleSet[1],
            ruleSetName: ruleSet[2],
            operations: ruleSet[3],
        };
    }
    return ruleSet;
};
exports.deserializeRuleSetRevisionV1 = deserializeRuleSetRevisionV1;
//# sourceMappingURL=revision.js.map