"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeAdditionalSignerV2 = exports.serializeAdditionalSignerV2 = exports.additionalSignerV2 = void 0;
const base58PublicKey_1 = require("./base58PublicKey");
const helpers_1 = require("./helpers");
const rule_1 = require("./rule");
const ruleType_1 = require("./ruleType");
const additionalSignerV2 = (publicKey) => ({
    type: 'AdditionalSigner',
    publicKey: (0, base58PublicKey_1.toBase58PublicKey)(publicKey),
});
exports.additionalSignerV2 = additionalSignerV2;
const serializeAdditionalSignerV2 = (rule) => {
    return Buffer.concat([
        (0, rule_1.serializeRuleHeaderV2)(ruleType_1.RuleTypeV2.AdditionalSigner, 32),
        (0, helpers_1.serializePublicKey)(rule.publicKey),
    ]);
};
exports.serializeAdditionalSignerV2 = serializeAdditionalSignerV2;
const deserializeAdditionalSignerV2 = (buffer, offset = 0) => {
    const publicKey = (0, helpers_1.deserializePublicKey)(buffer, offset + 8);
    return (0, exports.additionalSignerV2)(publicKey);
};
exports.deserializeAdditionalSignerV2 = deserializeAdditionalSignerV2;
//# sourceMappingURL=additionalSigner.js.map