"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeAmountV2 = exports.serializeAmountV2 = exports.amountV2 = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const helpers_1 = require("./helpers");
const rule_1 = require("./rule");
const ruleType_1 = require("./ruleType");
const shared_1 = require("../shared");
const amountV2 = (field, operator, amount) => ({
    type: 'Amount',
    field,
    operator: (0, shared_1.parseAmountOperatorString)(operator),
    amount,
});
exports.amountV2 = amountV2;
const serializeAmountV2 = (rule) => {
    const headerBuffer = (0, rule_1.serializeRuleHeaderV2)(ruleType_1.RuleTypeV2.Amount, 8 + 8 + 32);
    const amountAndOperatorBuffer = Buffer.alloc(16);
    beet.u64.write(amountAndOperatorBuffer, 0, rule.amount);
    beet.u64.write(amountAndOperatorBuffer, 8, (0, shared_1.parseAmountOperator)(rule.operator));
    const fieldBuffer = (0, helpers_1.serializeString32)(rule.field);
    return Buffer.concat([headerBuffer, amountAndOperatorBuffer, fieldBuffer]);
};
exports.serializeAmountV2 = serializeAmountV2;
const deserializeAmountV2 = (buffer, offset = 0) => {
    offset += 8;
    const amount = beet.u64.read(buffer, offset);
    const amountAsNumber = typeof amount === 'number' ? amount : amount.toNumber();
    offset += 8;
    const operator = Number(beet.u64.read(buffer, offset));
    offset += 8;
    const field = (0, helpers_1.deserializeString32)(buffer, offset);
    return (0, exports.amountV2)(field, operator, amountAsNumber);
};
exports.deserializeAmountV2 = deserializeAmountV2;
//# sourceMappingURL=amount.js.map