"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializePublicKey = exports.serializePublicKey = exports.deserializeString32 = exports.serializeString32 = void 0;
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
const web3_js_1 = require("@solana/web3.js");
const base58PublicKey_1 = require("./base58PublicKey");
const serializeString32 = (str) => {
    const buffer = Buffer.alloc(32);
    buffer.write(str);
    return buffer;
};
exports.serializeString32 = serializeString32;
const deserializeString32 = (buffer, offset = 0) => {
    return buffer
        .subarray(offset, offset + 32)
        .toString()
        .replace(/\u0000/g, '');
};
exports.deserializeString32 = deserializeString32;
const serializePublicKey = (publicKey) => {
    const buffer = Buffer.alloc(32);
    const web3JsPublicKey = typeof publicKey === 'string' ? new web3_js_1.PublicKey(publicKey) : publicKey;
    beetSolana.publicKey.write(buffer, 0, web3JsPublicKey);
    return buffer;
};
exports.serializePublicKey = serializePublicKey;
const deserializePublicKey = (buffer, offset = 0) => {
    return (0, base58PublicKey_1.toBase58PublicKey)(beetSolana.publicKey.read(buffer, offset));
};
exports.deserializePublicKey = deserializePublicKey;
//# sourceMappingURL=helpers.js.map