"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeIsWalletV2 = exports.serializeIsWalletV2 = exports.isWalletV2 = void 0;
const helpers_1 = require("./helpers");
const rule_1 = require("./rule");
const ruleType_1 = require("./ruleType");
const isWalletV2 = (field) => ({ type: 'IsWallet', field });
exports.isWalletV2 = isWalletV2;
const serializeIsWalletV2 = (rule) => {
    return Buffer.concat([
        (0, rule_1.serializeRuleHeaderV2)(ruleType_1.RuleTypeV2.IsWallet, 32),
        (0, helpers_1.serializeString32)(rule.field),
    ]);
};
exports.serializeIsWalletV2 = serializeIsWalletV2;
const deserializeIsWalletV2 = (buffer, offset = 0) => {
    offset += 8;
    const field = (0, helpers_1.deserializeString32)(buffer, offset);
    return (0, exports.isWalletV2)(field);
};
exports.deserializeIsWalletV2 = deserializeIsWalletV2;
//# sourceMappingURL=isWallet.js.map