"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeNotV2 = exports.serializeNotV2 = exports.notV2 = void 0;
const rule_1 = require("./rule");
const ruleType_1 = require("./ruleType");
const notV2 = (rule) => ({ type: 'Not', rule });
exports.notV2 = notV2;
const serializeNotV2 = (notRule) => {
    const ruleBuffer = (0, rule_1.serializeRuleV2)(notRule.rule);
    const headerBuffer = (0, rule_1.serializeRuleHeaderV2)(ruleType_1.RuleTypeV2.Not, ruleBuffer.length);
    return Buffer.concat([headerBuffer, ruleBuffer]);
};
exports.serializeNotV2 = serializeNotV2;
const deserializeNotV2 = (buffer, offset = 0) => {
    const rule = (0, rule_1.deserializeRuleV2)(buffer, offset + 8);
    return (0, exports.notV2)(rule);
};
exports.deserializeNotV2 = deserializeNotV2;
//# sourceMappingURL=not.js.map