"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializePdaMatchV2 = exports.serializePdaMatchV2 = exports.pdaMatchV2 = void 0;
const base58PublicKey_1 = require("./base58PublicKey");
const helpers_1 = require("./helpers");
const rule_1 = require("./rule");
const ruleType_1 = require("./ruleType");
const pdaMatchV2 = (pdaField, program, seedsField) => ({
    type: 'PdaMatch',
    pdaField,
    program: (0, base58PublicKey_1.toBase58PublicKey)(program),
    seedsField,
});
exports.pdaMatchV2 = pdaMatchV2;
const serializePdaMatchV2 = (rule) => {
    return Buffer.concat([
        (0, rule_1.serializeRuleHeaderV2)(ruleType_1.RuleTypeV2.PdaMatch, 96),
        (0, helpers_1.serializePublicKey)(rule.program),
        (0, helpers_1.serializeString32)(rule.pdaField),
        (0, helpers_1.serializeString32)(rule.seedsField),
    ]);
};
exports.serializePdaMatchV2 = serializePdaMatchV2;
const deserializePdaMatchV2 = (buffer, offset = 0) => {
    offset += 8;
    const program = (0, helpers_1.deserializePublicKey)(buffer, offset);
    offset += 32;
    const pdaField = (0, helpers_1.deserializeString32)(buffer, offset);
    offset += 32;
    const seedsField = (0, helpers_1.deserializeString32)(buffer, offset);
    offset += 32;
    return (0, exports.pdaMatchV2)(pdaField, program, seedsField);
};
exports.deserializePdaMatchV2 = deserializePdaMatchV2;
//# sourceMappingURL=pdaMatch.js.map