"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeProgramOwnedV2 = exports.serializeProgramOwnedV2 = exports.programOwnedV2 = void 0;
const helpers_1 = require("./helpers");
const rule_1 = require("./rule");
const ruleType_1 = require("./ruleType");
const base58PublicKey_1 = require("./base58PublicKey");
const programOwnedV2 = (field, program) => ({
    type: 'ProgramOwned',
    program: (0, base58PublicKey_1.toBase58PublicKey)(program),
    field,
});
exports.programOwnedV2 = programOwnedV2;
const serializeProgramOwnedV2 = (rule) => {
    return Buffer.concat([
        (0, rule_1.serializeRuleHeaderV2)(ruleType_1.RuleTypeV2.ProgramOwned, 64),
        (0, helpers_1.serializePublicKey)(rule.program),
        (0, helpers_1.serializeString32)(rule.field),
    ]);
};
exports.serializeProgramOwnedV2 = serializeProgramOwnedV2;
const deserializeProgramOwnedV2 = (buffer, offset = 0) => {
    offset += 8;
    const program = (0, helpers_1.deserializePublicKey)(buffer, offset);
    offset += 32;
    const field = (0, helpers_1.deserializeString32)(buffer, offset);
    offset += 32;
    return (0, exports.programOwnedV2)(field, program);
};
exports.deserializeProgramOwnedV2 = deserializeProgramOwnedV2;
//# sourceMappingURL=programOwned.js.map