"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeProgramOwnedListV2 = exports.serializeProgramOwnedListV2 = exports.programOwnedListV2 = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const helpers_1 = require("./helpers");
const rule_1 = require("./rule");
const ruleType_1 = require("./ruleType");
const base58PublicKey_1 = require("./base58PublicKey");
const programOwnedListV2 = (field, programs) => ({
    type: 'ProgramOwnedList',
    field,
    programs: programs.map(base58PublicKey_1.toBase58PublicKey),
});
exports.programOwnedListV2 = programOwnedListV2;
const serializeProgramOwnedListV2 = (rule) => {
    const length = 32 + 32 * rule.programs.length;
    const headerBuffer = (0, rule_1.serializeRuleHeaderV2)(ruleType_1.RuleTypeV2.ProgramOwnedList, length);
    const fieldBuffer = (0, helpers_1.serializeString32)(rule.field);
    const publicKeyBuffers = rule.programs.map((publicKey) => (0, helpers_1.serializePublicKey)(publicKey));
    return Buffer.concat([headerBuffer, fieldBuffer, ...publicKeyBuffers]);
};
exports.serializeProgramOwnedListV2 = serializeProgramOwnedListV2;
const deserializeProgramOwnedListV2 = (buffer, offset = 0) => {
    const length = beet.u32.read(buffer, offset + 4);
    const numberOfPublicKeys = Math.floor((length - 32) / 32);
    offset += 8;
    const field = (0, helpers_1.deserializeString32)(buffer, offset);
    offset += 32;
    const programs = [];
    for (let index = 0; index < numberOfPublicKeys; index++) {
        programs.push((0, helpers_1.deserializePublicKey)(buffer, offset));
        offset += 32;
    }
    return (0, exports.programOwnedListV2)(field, programs);
};
exports.deserializeProgramOwnedListV2 = deserializeProgramOwnedListV2;
//# sourceMappingURL=programOwnedList.js.map