"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeProgramOwnedTreeV2 = exports.serializeProgramOwnedTreeV2 = exports.programOwnedTreeV2 = void 0;
const helpers_1 = require("./helpers");
const rule_1 = require("./rule");
const ruleType_1 = require("./ruleType");
const programOwnedTreeV2 = (pubkeyField, proofField, root) => ({
    type: 'ProgramOwnedTree',
    pubkeyField,
    proofField,
    root: [...root],
});
exports.programOwnedTreeV2 = programOwnedTreeV2;
const serializeProgramOwnedTreeV2 = (rule) => {
    return Buffer.concat([
        (0, rule_1.serializeRuleHeaderV2)(ruleType_1.RuleTypeV2.ProgramOwnedTree, 96),
        (0, helpers_1.serializeString32)(rule.pubkeyField),
        (0, helpers_1.serializeString32)(rule.proofField),
        new Uint8Array(rule.root),
    ]);
};
exports.serializeProgramOwnedTreeV2 = serializeProgramOwnedTreeV2;
const deserializeProgramOwnedTreeV2 = (buffer, offset = 0) => {
    offset += 8;
    const pubkeyField = (0, helpers_1.deserializeString32)(buffer, offset);
    offset += 32;
    const proofField = (0, helpers_1.deserializeString32)(buffer, offset);
    offset += 32;
    const root = new Uint8Array(buffer.subarray(offset, offset + 32));
    return (0, exports.programOwnedTreeV2)(pubkeyField, proofField, root);
};
exports.deserializeProgramOwnedTreeV2 = deserializeProgramOwnedTreeV2;
//# sourceMappingURL=programOwnedTree.js.map