"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializePubkeyMatchV2 = exports.serializePubkeyMatchV2 = exports.pubkeyMatchV2 = void 0;
const helpers_1 = require("./helpers");
const rule_1 = require("./rule");
const ruleType_1 = require("./ruleType");
const base58PublicKey_1 = require("./base58PublicKey");
const pubkeyMatchV2 = (field, publicKey) => ({
    type: 'PubkeyMatch',
    publicKey: (0, base58PublicKey_1.toBase58PublicKey)(publicKey),
    field,
});
exports.pubkeyMatchV2 = pubkeyMatchV2;
const serializePubkeyMatchV2 = (rule) => {
    return Buffer.concat([
        (0, rule_1.serializeRuleHeaderV2)(ruleType_1.RuleTypeV2.PubkeyMatch, 64),
        (0, helpers_1.serializePublicKey)(rule.publicKey),
        (0, helpers_1.serializeString32)(rule.field),
    ]);
};
exports.serializePubkeyMatchV2 = serializePubkeyMatchV2;
const deserializePubkeyMatchV2 = (buffer, offset = 0) => {
    offset += 8;
    const publicKey = (0, helpers_1.deserializePublicKey)(buffer, offset);
    offset += 32;
    const field = (0, helpers_1.deserializeString32)(buffer, offset);
    offset += 32;
    return (0, exports.pubkeyMatchV2)(field, publicKey);
};
exports.deserializePubkeyMatchV2 = deserializePubkeyMatchV2;
//# sourceMappingURL=pubkeyMatch.js.map