"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializePubkeyTreeMatchV2 = exports.serializePubkeyTreeMatchV2 = exports.pubkeyTreeMatchV2 = void 0;
const helpers_1 = require("./helpers");
const rule_1 = require("./rule");
const ruleType_1 = require("./ruleType");
const pubkeyTreeMatchV2 = (pubkeyField, proofField, root) => ({ type: 'PubkeyTreeMatch', pubkeyField, proofField, root: [...root] });
exports.pubkeyTreeMatchV2 = pubkeyTreeMatchV2;
const serializePubkeyTreeMatchV2 = (rule) => {
    return Buffer.concat([
        (0, rule_1.serializeRuleHeaderV2)(ruleType_1.RuleTypeV2.PubkeyTreeMatch, 96),
        (0, helpers_1.serializeString32)(rule.pubkeyField),
        (0, helpers_1.serializeString32)(rule.proofField),
        new Uint8Array(rule.root),
    ]);
};
exports.serializePubkeyTreeMatchV2 = serializePubkeyTreeMatchV2;
const deserializePubkeyTreeMatchV2 = (buffer, offset = 0) => {
    offset += 8;
    const pubkeyField = (0, helpers_1.deserializeString32)(buffer, offset);
    offset += 32;
    const proofField = (0, helpers_1.deserializeString32)(buffer, offset);
    offset += 32;
    const root = new Uint8Array(buffer.subarray(offset, offset + 32));
    return (0, exports.pubkeyTreeMatchV2)(pubkeyField, proofField, root);
};
exports.deserializePubkeyTreeMatchV2 = deserializePubkeyTreeMatchV2;
//# sourceMappingURL=pubkeyTreeMatch.js.map