/// <reference types="node" />
import { RuleSetRevisionV1, RuleV1 } from '../v1';
import { Base58PublicKey } from './base58PublicKey';
import { RuleV2 } from './rule';
export type RuleSetRevisionV2 = {
    libVersion: 2;
    name: string;
    owner: Base58PublicKey;
    operations: Record<string, RuleV2>;
};
export declare const serializeRuleSetRevisionV2: (ruleSet: RuleSetRevisionV2) => Buffer;
export declare const deserializeRuleSetRevisionV2: (buffer: Buffer, offset?: number) => RuleSetRevisionV2;
export declare const getRuleSetRevisionV2FromV1: (ruleSetV1: RuleSetRevisionV1) => RuleSetRevisionV2;
export declare const getRuleV2FromV1: (ruleV1: RuleV1) => RuleV2;
