/// <reference types="node" />
import BN from 'bn.js';
import { AdditionalSignerRuleV2 } from './additionalSigner';
import { AllRuleV2 } from './all';
import { AmountRuleV2 } from './amount';
import { AnyRuleV2 } from './any';
import { NamespaceRuleV2 } from './namespace';
import { NotRuleV2 } from './not';
import { PassRuleV2 } from './pass';
import { PdaMatchRuleV2 } from './pdaMatch';
import { ProgramOwnedRuleV2 } from './programOwned';
import { ProgramOwnedListRuleV2 } from './programOwnedList';
import { ProgramOwnedTreeRuleV2 } from './programOwnedTree';
import { PubkeyListMatchRuleV2 } from './pubkeyListMatch';
import { PubkeyMatchRuleV2 } from './pubkeyMatch';
import { PubkeyTreeMatchRuleV2 } from './pubkeyTreeMatch';
import { RuleTypeV2 } from './ruleType';
export type RuleV2 = AdditionalSignerRuleV2 | AllRuleV2 | AmountRuleV2 | AnyRuleV2 | NamespaceRuleV2 | NotRuleV2 | PassRuleV2 | PdaMatchRuleV2 | ProgramOwnedRuleV2 | ProgramOwnedListRuleV2 | ProgramOwnedTreeRuleV2 | PubkeyListMatchRuleV2 | PubkeyMatchRuleV2 | PubkeyTreeMatchRuleV2;
export declare const serializeRuleV2: (rule: RuleV2) => Buffer;
export declare const serializeRulesV2: (rules: RuleV2[]) => Buffer;
export declare const deserializeRuleV2: (buffer: Buffer, offset?: number) => RuleV2;
export declare const deserializeRulesV2: (buffer: Buffer, size: number | BN, offset?: number) => RuleV2[];
export declare const serializeRuleHeaderV2: (ruleType: RuleTypeV2, length: number) => Buffer;
