"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.serializeRuleHeaderV2 = exports.deserializeRulesV2 = exports.deserializeRuleV2 = exports.serializeRulesV2 = exports.serializeRuleV2 = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const bn_js_1 = __importDefault(require("bn.js"));
const additionalSigner_1 = require("./additionalSigner");
const all_1 = require("./all");
const amount_1 = require("./amount");
const any_1 = require("./any");
const namespace_1 = require("./namespace");
const not_1 = require("./not");
const pass_1 = require("./pass");
const pdaMatch_1 = require("./pdaMatch");
const programOwned_1 = require("./programOwned");
const programOwnedList_1 = require("./programOwnedList");
const programOwnedTree_1 = require("./programOwnedTree");
const pubkeyListMatch_1 = require("./pubkeyListMatch");
const pubkeyMatch_1 = require("./pubkeyMatch");
const pubkeyTreeMatch_1 = require("./pubkeyTreeMatch");
const ruleType_1 = require("./ruleType");
const serializeRuleV2 = (rule) => {
    const type = rule.type;
    switch (type) {
        case 'AdditionalSigner':
            return (0, additionalSigner_1.serializeAdditionalSignerV2)(rule);
        case 'All':
            return (0, all_1.serializeAllV2)(rule);
        case 'Amount':
            return (0, amount_1.serializeAmountV2)(rule);
        case 'Any':
            return (0, any_1.serializeAnyV2)(rule);
        case 'Namespace':
            return (0, namespace_1.serializeNamespaceV2)(rule);
        case 'Not':
            return (0, not_1.serializeNotV2)(rule);
        case 'Pass':
            return (0, pass_1.serializePassV2)(rule);
        case 'PdaMatch':
            return (0, pdaMatch_1.serializePdaMatchV2)(rule);
        case 'ProgramOwned':
            return (0, programOwned_1.serializeProgramOwnedV2)(rule);
        case 'ProgramOwnedList':
            return (0, programOwnedList_1.serializeProgramOwnedListV2)(rule);
        case 'ProgramOwnedTree':
            return (0, programOwnedTree_1.serializeProgramOwnedTreeV2)(rule);
        case 'PubkeyListMatch':
            return (0, pubkeyListMatch_1.serializePubkeyListMatchV2)(rule);
        case 'PubkeyMatch':
            return (0, pubkeyMatch_1.serializePubkeyMatchV2)(rule);
        case 'PubkeyTreeMatch':
            return (0, pubkeyTreeMatch_1.serializePubkeyTreeMatchV2)(rule);
        default:
            const neverType = type;
            throw new Error('Unknown rule type: ' + neverType);
    }
};
exports.serializeRuleV2 = serializeRuleV2;
const serializeRulesV2 = (rules) => {
    return Buffer.concat(rules.map(exports.serializeRuleV2));
};
exports.serializeRulesV2 = serializeRulesV2;
const deserializeRuleV2 = (buffer, offset = 0) => {
    const type = beet.u32.read(buffer, offset);
    switch (type) {
        case ruleType_1.RuleTypeV2.AdditionalSigner:
            return (0, additionalSigner_1.deserializeAdditionalSignerV2)(buffer, offset);
        case ruleType_1.RuleTypeV2.All:
            return (0, all_1.deserializeAllV2)(buffer, offset);
        case ruleType_1.RuleTypeV2.Amount:
            return (0, amount_1.deserializeAmountV2)(buffer, offset);
        case ruleType_1.RuleTypeV2.Any:
            return (0, any_1.deserializeAnyV2)(buffer, offset);
        case ruleType_1.RuleTypeV2.Namespace:
            return (0, namespace_1.deserializeNamespaceV2)(buffer, offset);
        case ruleType_1.RuleTypeV2.Not:
            return (0, not_1.deserializeNotV2)(buffer, offset);
        case ruleType_1.RuleTypeV2.Pass:
            return (0, pass_1.deserializePassV2)(buffer, offset);
        case ruleType_1.RuleTypeV2.PdaMatch:
            return (0, pdaMatch_1.deserializePdaMatchV2)(buffer, offset);
        case ruleType_1.RuleTypeV2.ProgramOwned:
            return (0, programOwned_1.deserializeProgramOwnedV2)(buffer, offset);
        case ruleType_1.RuleTypeV2.ProgramOwnedList:
            return (0, programOwnedList_1.deserializeProgramOwnedListV2)(buffer, offset);
        case ruleType_1.RuleTypeV2.ProgramOwnedTree:
            return (0, programOwnedTree_1.deserializeProgramOwnedTreeV2)(buffer, offset);
        case ruleType_1.RuleTypeV2.PubkeyListMatch:
            return (0, pubkeyListMatch_1.deserializePubkeyListMatchV2)(buffer, offset);
        case ruleType_1.RuleTypeV2.PubkeyMatch:
            return (0, pubkeyMatch_1.deserializePubkeyMatchV2)(buffer, offset);
        case ruleType_1.RuleTypeV2.PubkeyTreeMatch:
            return (0, pubkeyTreeMatch_1.deserializePubkeyTreeMatchV2)(buffer, offset);
        default:
            throw new Error('Unknown rule type: ' + type);
    }
};
exports.deserializeRuleV2 = deserializeRuleV2;
const deserializeRulesV2 = (buffer, size, offset = 0) => {
    const rules = [];
    const sizeAsNumber = new bn_js_1.default(size).toNumber();
    for (let index = 0; index < sizeAsNumber; index++) {
        const length = beet.u32.read(buffer, offset + 4);
        rules.push((0, exports.deserializeRuleV2)(buffer, offset));
        offset += 8 + length;
    }
    return rules;
};
exports.deserializeRulesV2 = deserializeRulesV2;
const serializeRuleHeaderV2 = (ruleType, length) => {
    const buffer = Buffer.alloc(8);
    beet.u32.write(buffer, 0, ruleType);
    beet.u32.write(buffer, 4, length);
    return buffer;
};
exports.serializeRuleHeaderV2 = serializeRuleHeaderV2;
//# sourceMappingURL=rule.js.map